# ximdb v1.0 by some unknown scriptkiddie.
#
# we made this because we thought b0untys imdb script is too slow because
# hes using that lame tcl http package thats lags like hell.
# so here we brought you a version using lynx, youll see the difference.
#
# plot summary, cast list and fully configurable output style is only available
# in a private version.
# so lamers, dont ask, you wont get it.
#
#
#
# commands:
# ---------
#
# !imdb <search string>                   - simple imdb query
# !imdb -p <search string>                - simple imdb query with
#                                           releasename parsing
#
#
#
## config:

# file for lynxs imdb dump
set imdb(dump) "/home/lamer/eggdrop/imdb.dump"

# movie check trigger
set imdb(checktrigger) "!imdb"

# your blowcryptkey
set imdb(key) "meinesiteistscheisseunddasistauchgutso"

# your not that much configurable output
set imdb(layout) "\0034i\003mdb\002:\002 ->"

########################################################################
package require http

# the binds
bind pub - $imdb(checktrigger) imdbcheck

set CUTer(langs) "german english spanish dutch frensh polish swedub swedish swesub"
set CUTer(types) "xxx dvdrip ld ts dl subbed line dubbed dubbed mic screener dvdscreener tvrip dtv proper limited custom crypted repack uncut internal unsubbed ws dvdscr satrip nfo dc se ac3 fs pal ntsc multisubs heb sub"
set CUTer(forms) "xvid divx vcd svcd dvdr"

proc imdbparserel {rel} {
  global CUTer
  set rel [lreplace [string map {. " " _ " "} $rel] end end]
  foreach LANG $CUTer(langs) { set Ls [lsearch [string tolower $rel] [string tolower $LANG]]; if {$Ls != "-1"} { set rel [lreplace $rel $Ls $Ls] } }
  foreach TYPE $CUTer(types) { set Ts [lsearch [string tolower $rel] [string tolower $TYPE]]; if {$Ts != "-1"} { set rel [lreplace $rel $Ts $Ts] } }
  foreach FORM $CUTer(forms) { set Fs [lsearch [string tolower $rel] [string tolower $FORM]]; if {$Fs != "-1"} { set rel [lreplace $rel $Fs $Fs] } }
  return "$rel"
}

proc imdbcheck {nick uhost hand chan arg} {
	global imdb
	if {[lindex $arg 0] == "-p"} {
		set rel [lindex $arg 1]
		set parsed [imdbparserel $rel]
		if {[string is integer [lindex $parsed end]] && [string length [lindex $parsed end]] == 4} {
			set parsed [lrange $parsed 0 end-1]
		}
	} else {
		set parsed $arg
	}
	# now lets get the imdb url
	set url "http://www.imdb.com/find?q=[string map {" " %20} $parsed];tt=on;nm=on;mx=20"
	exec lynx -dump "$url" > $imdb(dump)
	set furl "N/A"
        set dump [open $imdb(dump) r]   
        while {![eof $dump]} {
	        gets $dump line
		if {[string match *title/tt* $line] && $furl == "N/A" && ![string match *LYNXIMGMAP* $line]} {
			set furl [lindex $line end]
		}
	}
	close $dump
	exec rm -f $imdb(dump)
        exec lynx -dump "$furl" > $imdb(dump)
	set mpaa "n/a"
	set runtime "n/a"
	set country "n/a"
	set color "n/a"
	set top250 "n/a"
	set rating "n/a"
	set votes "n/a"
	set name "n/a"
	set tagline "n/a"
	set director "n/a"
	set writer "n/a"
	set genre "n/a"
	set sound "n/a"
	set tvseries 0
	set dline 0
	set mi 0
	set dirget 0
        set dump [open $imdb(dump) r]
        while {![eof $dump]} {
	        gets $dump line
		incr mi
		if {[string match *MPAA:* $line]} {set mpaa [string range $line 14 end]}
		if {[string match *Runtime:* $line]} {set runtime [string range $line 12 end]}
		if {[string match *Country:* $line]} {set country [string range $line 17 end]}
		if {[string match *Color:* $line]} {set color [lrange $line 1 end]}
		if {[string match "*top 250:*" $line]} {set top250 [string range $line 22 end]}
		if {[string match "*User Rating:*" $line]} {
			set rating [lindex $line end-3]
			set votes [string range [lindex $line end-2] 1 end]
		}
		if {[string match "*I have seen this movie and would like to*" $line] && $name == "n/a"} {set dline [expr $mi + 2]}
		if {$mi == $dline} {set name [lrange $line 0 end-1]}
		if {[string match *Tagline:* $line]} {set tagline [string range $line 12 end-11]}
		if {[string match *Genre:* $line]} {set genre [string range $line 11 end]}
		if {[string match "*Sound Mix:*" $line]} {set sound [string range $line 14 end]}
		if {$dirget == 2 && $line != ""} {
			if {$writer != "n/a"} {set writer "$writer, [string range $line 7 end]"}
			if {$writer == "n/a"} {set writer [string range $line 7 end]}
		}
		if {[string match "*Writing credits*" $line] && $dirget == 1} {set dirget 2}
		if {$dirget == 2 && $line == ""} {set dirget x}
		if {$dirget == 1} {
			if {$director != "n/a"} {set director "$director, [string range $line 7 end]"}
			if {$director == "n/a"} {set director [string range $line 7 end]}
		}
		
		if {[string match "*Directed by*" $line] && $dirget == 0} {set dirget 1}
	}
	close $dump

	# now some re-formatting to make this thing look nice
	set writer [string map {\] "" & "" " ," "," " ..." ", ..."} $writer]
	set writer [string map {", (more)" ""} $writer]
	set director [string map {"(more)" "" \] "" \[ ""} $director]
	set genre [string map {1 "" 2 "" 3 "" 4 "" 5 "" 6 "" 7 "" 8 "" 9 "" 0 "" \[ "" \] "" " / " ", " "(more)" ""} $genre]
	set sound [string map {1 "" 2 "" 3 "" 4 "" 5 "" 6 "" 7 "" 8 "" 9 "" 0 "" \[ "" \] "" " / " ", " "(more)" ""} $sound]
	set color [string map {1 "" 2 "" 3 "" 4 "" 5 "" 6 "" 7 "" 8 "" 9 "" 0 "" \[ "" \] "" " / " ", " "(more)" "" \} "" \{ ""} $color]
	set country [string map {1 "" 2 "" 3 "" 4 "" 5 "" 6 "" 7 "" 8 "" 9 "" 0 "" \[ "" \] "" " / " ", " "(more)" ""} $country]
	if {[string match "*TV-Series*" $name]} {
		set name [string map {\{ "" \} "" \[ "" \] "" "TV-Series" ""} $name]
		set name [lrange $name 0 end-1]
		set tvseries 1
	}

	# and finally the output
	if {$name == "n/a"} {
		putserv "PRIVMSG $chan :$imdb(layout) \002error\002: not found or parsing error."
	} else {
		if {$tvseries == 0} {
			putserv "PRIVMSG $chan :$imdb(layout) \002$name\002 ($country) -> rating\002:\002 \002$rating\002 ($votes votes) top250\002:\002 $top250"
		} else {
			putserv "PRIVMSG $chan :$imdb(layout) \002$name\002 ($country) (\002TV\002) -> rating\002:\002 \002$rating\002 ($votes votes) top250\002:\002 $top250"
		}
		if {$genre != "n/a"} {putserv "PRIVMSG $chan :$imdb(layout) Genre: $genre"}
		if {$runtime != "n/a" && $color != "n/a"} {putserv "PRIVMSG $chan :$imdb(layout) Runtime: $runtime Color: $color"}
		if {$sound != "n/a"} {putserv "PRIVMSG $chan :$imdb(layout) Sound Mix: $sound"}
		if {$tagline != "n/a"} {putserv "PRIVMSG $chan :$imdb(layout) Tagline: $tagline"}
		if {$mpaa != "n/a"} {putserv "PRIVMSG $chan :$imdb(layout) MPAA: $mpaa"}
		if {$director != "n/a"} {putserv "PRIVMSG $chan :$imdb(layout) Directed by: $director"}
		if {$writer != "n/a"} {putserv "PRIVMSG $chan :$imdb(layout) Writing Credits: $writer"}
		putserv "PRIVMSG $chan :$imdb(layout) -> \002EOF\002."
	}
}

putlog "imdb check v1.0 loaded."
